#!/usr/bin/Rscript 

args <- commandArgs(T)
print(args[1])
print(args[2])
print(args[3])

read.delim(args[2], header=F, stringsAsFactors=F) -> qc
read.delim(args[1], header=F, stringsAsFactors=F) -> d

#unique(unlist(strsplit(d$V3, "\\|"))) -> targets
targets <- qc$V1
d[,7]/d[,4] * 100 -> d$pctREF
d[,8]/d[,4] * 100 -> d$pctVAR

pdf(args[3], width=14)
for (i in targets) {
	sel <- grepl(i, d$V3)
	print(i)
	for (c in unique(d$V1[sel])) {
		csel <- d$V1 == c
		print(c)
		reg <- paste(range(d$V2[sel & csel]), collapse="-", sep="-")
		creg <- paste(c, reg, sep=":")
		print(reg)
		print(creg)
		plot(d[sel & csel,c(2,4)], type="l", ylim=c(0,max(d[sel & csel,4])), main=paste(i, creg, sep=" "), xlab="position", ylab="depth")
		lines(d[sel & csel,c(2,7)], type="l", col=4)
		lines(d[sel & csel,c(2,8)], type="l", col=2)
		limP <- range(d[sel & csel,2])
		abline(v=c(limP[1], limP[1] + 150, limP[2] - 150, limP[2]),lty=4)
		
		plot(d[sel & csel,2], d$pctREF[sel & csel], type="l", ylim=c(0,100), main=paste(i, creg, sep=" "), xlab="position", ylab="%")
		lines(d[sel & csel,2], d$pctVAR[sel & csel], type="l", col=2)
		abline(h=c(1,5,10,50,90,95,99), lty=3, col=1)
		abline(v=c(limP[1], limP[1] + 150, limP[2] - 150, limP[2]),lty=4)
	}
}
hist(d$pctVAR[d$pctVAR < 20], breaks=40, ylim=c(0,1000))
hist(d$pctREF[d$pctREF > 80], breaks=40, ylim=c(0,1000))

dev.off()

print(summary(d$pctVAR))


